//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  LimeGreen

//
//
//
//
//

extern int    EnvelopePeriod  = 15;
extern int    EnvelopeMaShift = 0;
extern int    EnvelopeMaMode  = MODE_EMA;
extern int    UpperPrice      = 0;
extern int    LowerPrice      = 0;
extern double Deviation       = 0.25;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double UpEnv[];
double DnEnv[];
double trend[];

//
//
//
//                    
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,UpEnv);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,DnEnv);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);  
   SetIndexBuffer(2,trend);
   SetIndexShift(0,EnvelopeMaShift);
   SetIndexShift(1,EnvelopeMaShift);
   IndicatorShortName("envelopes("+EnvelopePeriod+")");
return(0);
}  
  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0; i--)
   {
      double tUpEnv = (1+Deviation/100)*iMA(NULL,0,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,i);
      double tDnEnv = (1-Deviation/100)*iMA(NULL,0,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,i);
      
      trend[i] = trend[i+1];
         if (Close[i]>tDnEnv) trend[i] = 1;
         if (Close[i]<tUpEnv) trend[i] =-1;
         if (trend[i] ==  1) {UpEnv[i] = EMPTY_VALUE; DnEnv[i] = tDnEnv; }
         if (trend[i] == -1) {DnEnv[i] = EMPTY_VALUE; UpEnv[i] = tUpEnv; }
   }

          //
         //
         //
         //
         //
         
         if (alertsOn)
         {
           if (alertsOnCurrent)
                int whichBar = 0;
           else     whichBar = 1;
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("uptrend");
           else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," envelope ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," envelopes "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
 
   

